#Usinage
#V0.0
#Name: Usinage.rb
#Date 2013 04 26
#Portions of this code are modifications of examples from Trimble
# Description : Creates grooves 

require 'sketchup.rb'

#Sketchup.send_action "showRubyPanel:"

class Usinage #*****************************************************************
   #@u_step=0 start,  =1 select component, =2 first edge, =3 second edge
   #Problem handler @oops =0 ok,  1 not component, 2 edge2 not valid, 3  or 4:pb in the path 
   
   CONV=25.4


def initialize
   @ip1=nil
   @ip2=nil
   @ip=nil

   $select_path=Array.new

   #defaults data for input forms
   if !@r_depth then @r_depth=(15/CONV).to_l end           
   if !@shoulder1 then @shoulder1=0.to_l end 
   if !@shoulder2 then @shoulder2=0.to_l end 
   if !@r_dist then @r_dist=(0/CONV).to_l end
   if !@r_width then @r_width=(8/CONV).to_l end 
  
end 
 
def activate
   #first activation of the tool
   @ip1 = Sketchup::InputPoint.new           
   @ip2= Sketchup::InputPoint.new
   @ip= Sketchup::InputPoint.new
   @u_step=1
   model=Sketchup.active_model
   view = Sketchup.active_model.active_view
   @ss=model.selection
   @ss.clear
   model.close_active 
   @message="Select the component, [Space bar] to exit"
   Sketchup::set_status_text @message,SB_PROMPT
   self.reset(view)
end #def activate
   
def deactivate(view)
   view.invalidate 
   if ((@edge2!=nil)&&(@edge2.deleted?!=true)) then @edge2.hidden=false end 
end

def resume(view)
   view.invalidate
   Sketchup::set_status_text @message,SB_PROMPT
end
  

def onCancel(reason, view)
   #onCancel is called when user hits escape etc
   #UI.messagebox("Cancel, reason = " + reason.to_s)
   view.invalidate
   @oops=0
   @ss.clear
   if ((@edge2!=nil)&&(@edge2.deleted?!=true)) then @edge2.hidden=false end 
   @edge1=nil
   @edge2=nil 
   @u_step=1 
   @message = "Select the component, [Space bar] to exit" 
   Sketchup::set_status_text @message,SB_PROMPT
   self.reset(view)
end

def reset(view) 
    # clear the InputPoints
    @ip1.clear
    @ip2.clear   
    if(view)
        view.tooltip = nil
        view.invalidate
    end
   Sketchup::set_status_text @message,SB_PROMPT
end 


def getMenu(menu)
    menu.add_item("End of selection") {
    @ss.clear
    @edge2.hidden=false
    view = Sketchup.active_model.active_view
    @edge1=$select_path.first
           
    p1=@edge1.start.position
    p2=@edge1.end.position			          
    p3=@edge2.start.position
    p4=@edge2.end.position	

   @oops=0
   if(p1==p3||p1==p4) #f
      ext2 = p4
      orig=p1
      ext1=p2
      if(p1==p4) then ext2=p3 end
   elsif(p2==p3||p2==p4) #f
      orig=p2
      ext2 = p4
      ext1=p1
      if(p2==p4) then ext2=p3 end 
      else #f
          @oops=3
    end #f
if (@oops==0) 
      if (@@Usinage == "Rainure_Feuillure") then  panel_rainure_feuillure(view) end 
#      if (@@Usinage == "Moulure") then panel_moulure(view) end 
end    
   if (@oops==0) #13
       u=Geom::Vector3d.new(ext2.x-orig.x,ext2.y-orig.y,ext2.z-orig.z)
       uu=u.normalize 
       @ss.clear
       $leng=0
       $select_path.each {|e|$leng=$leng+e.length}
       l_dep=0 
       r_sens=$s_d 

       if (@shoulder1>0)
         #the code has been remoted for this example 
      end #shoulder1>0

       i_t=0
       if (@shoulder2>0)
         #the code has been remoted for this example 
       end #shoulder2>0



       e=$select_path.first
       v=Geom::Vector3d.new(e.end.position.x-e.start.position.x,e.end.position.y-e.start.position.y,e.end.position.z-e.start.position.z)
       vv=v.normalize 
       w=vv.cross uu
       ww=w.normalize
       orig=e.end.position 
       if ($s_d==false) then  orig=e.start.position end 
       back=Geom::Transformation.axes(orig,ww,uu,vv)
        pt = Geom::Point3d.new(@r_depth/2, 0, 0)
        pt=pt.transform(back)
        result = $sup_face.classify_point(pt)
        dx=-1
        if ((result == Sketchup::Face::PointInside)||(result == Sketchup::Face::PointOnEdge)) then dx=1 end
        orig=e.start.position 
        if ($s_d==false) then  orig=e.end.position end 
        back=Geom::Transformation.axes(orig,ww,uu,vv)
         u_material=$sup_face.material
         if (@@Usinage == "Rainure_Feuillure") then make_rainure_feuillure(view,u_material,back,dx) end 


    end #13
   if (@oops==5)
      onCancel(result, view)      
   else
      Sketchup.active_model.commit_operation
      Sketchup::set_status_text "Tooling done",SB_PROMPT
      result=UI.messagebox "New tooling ? ", MB_YESNO
      if result==7 then Sketchup.send_action("selectSelectionTool:") end
      if result==6 then onCancel(result, view) end
      @u_step=1       
      $select_path=[]        
      @ss.clear
   end  
   }
end

def onRButtonDown(flags, x, y, view)
#    Sketchup::set_status_text message,SB_PROMPT   
end #def onRButtonDown

   
def onMouseMove(flags, x, y, view)
   #cruise for a point in component
   Sketchup::set_status_text @message,SB_PROMPT
   if (@u_step==2 or @u_step==3)
      @ip2.pick view, x, y
      if (@ip2.valid?) 
         changed=@ip2 != @ip1
         @ip1.copy! @ip2 
         if (changed and (@ip1.display? or @displayed))
            view.invalidate 
         end
      end
   end
end #def onMouseMove
 
def onLButtonDown(flags, x, y, view)
   if(@u_step==1) #a
     @oops=1 
      ph=view.pick_helper
      ph.do_pick x,y
      $selected_comp=ph.best_picked
      if $selected_comp #b
         type=$selected_comp.typename
         if type=="ComponentInstance" #c
            model=Sketchup.active_model
            @ss=model.selection
            @ss.add($selected_comp)
            $codef = $selected_comp.definition
            @message="Show the first edge"
            Sketchup::set_status_text @message,SB_PROMPT
            @u_step=2
            @oops=0       
         end #c
      end #b
   elsif(@u_step==2)#a
      @ip.pick view,x,y
      @oops=2 
      if(@ip.valid?)&&(@ip.edge)&&($selected_comp.definition==@ip.edge.parent)
         @oops=0
         @edge2=@ip.edge
         @edge2.hidden =true
        @message="Click on the edges of the follow-me path. End : right click"   
         Sketchup::set_status_text @message,SB_PROMPT
         @ss.clear	
         @u_step=3
       end         		        		        		
   elsif(@u_step==3) #a  1
      @oops=3
      ph = view.pick_helper
      ph.do_pick x,y
      e =ph.picked_edge
      if (e==nil) then @oops=5 end 
      if (e!=nil)&&($select_path.length==0)
         ee=e
         if(e.curve) then ee=e.curve.first_edge end 
         face =@edge2.common_face ee
         if (face!=nil)
            faces=Array.new
            faces=e.faces
            $sup_face=faces[0]
             if ($sup_face==face) then $sup_face=faces[1] end
         end 
      end 
      if(e!=nil)&&($selected_comp.definition==e.parent)&&($sup_face!=nil) #b3
         @oops=0
         if ($select_path.length==0) # first edge selected for path 
            if(e.curve)
               s_curve=true
               ee=e.curve.first_edge
               if(ee.start.position!=@edge2.start.position)&&(ee.start.position!=@edge2.end.position)&&
               (ee.end.position!=@edge2.start.position)&&(ee.end.position!=@edge2.end.position)
                  s_curve=false
                  ee=e.curve.last_edge
                  if(ee.start.position!=@edge2.start.position)&&(ee.start.position!=@edge2.end.position)&&
                     (ee.end.position!=@edge2.start.position)&&(ee.end.position!=@edge2.end.position)
                       @oops=3
                  end 
               end 
               if (@oops==0)
                 $s_d=false
                 if(ee.start.position==@edge2.start.position)||(ee.start.position==@edge2.end.position) then $s_d=true end
                 e.curve.edges.each{|eee|  $select_path<<eee }              
                 if(s_curve==false) then $select_path.reverse! end
                 @ss.add(e.curve.edges)
               end 
            else # e not a edge.curve
              if(e.start.position!=@edge2.start.position)&&(e.start.position!=@edge2.end.position)&&
                 (e.end.position!=@edge2.start.position)&&(e.end.position!=@edge2.end.position)
                  @oops=3
              else
                 $s_d=false
                 if(e.start.position==@edge2.start.position)||(e.start.position==@edge2.end.position) then $s_d=true end          
               end 
               if (@oops==0)
                  $select_path<<e             
                  @ss.add(e)
               end 
              end #is a curve or not

           else #not the first edge selected
              if(e.curve) 
                 remove_OK = false
                 e.curve.each_edge {|ee| 
                   $select_path.each {|eee| 
                       if (ee==eee) then remove_OK = true end 
                    }
                 } 
                  if (remove_OK==true)
                     $select_path.delete(e.curve.edges)
                     @ss.remove(e.curve.edges)
                  else #add the curve if join with previous
                     ee=$select_path.last
                     s_curve=true
                     eee=e.curve.first_edge
                     if(eee.start.position!=ee.start.position)&&(eee.start.position!=ee.end.position)&&
                       (eee.end.position!=ee.start.position)&&(eee.end.position!=ee.end.position)
                         s_curve=false
                         eee=e.curve.last_edge
                         if(eee.start.position!=ee.start.position)&&(eee.start.position!=ee.end.position)&&
                            (eee.end.position!=ee.start.position)&&(eee.end.position!=ee.end.position)
                             @oops=4
                         end 
                     end 
                     if(@oops==0)
                        array=Array.new
                        e.curve.edges.each{|eee|  array<<eee}              
                        if(s_curve==false) then array.reverse! end
                        array.each{|eee|  $select_path<<eee}
                        @ss.add(e.curve.edges)
                     end 
                 end 
              else # not a curve 
                 remove_OK = false
                $select_path.each {|ee| 
                    if (e==ee) then remove_OK = true end 
                 }
                 if (remove_OK==true)
                    @ss.remove(e) 
                    $select_path.delete(e)
                 else
                    ee=$select_path.last
                    if(e.start.position!=ee.start.position)&&(e.start.position!=ee.end.position)&&
                       (e.end.position!=ee.start.position)&&(e.end.position!=ee.end.position)
                       @oops=4
                    else
                       $select_path<<e              
                       @ss.add(e)
                    end 
             
                 end 
           end 
         end # @oops==0
      end #b3 

   end #a 1


   #Selection problem handler @oops, 0 ok,  1 not compe, 2 edge2 not valid, 3 path  not valid 
   case @oops 
      when 1
         UI.messagebox "Not a component"
       when 2
         UI.messagebox "Not a edge of the component"
       when 3
         UI.messagebox "Edge begining not with the first one"
       when 4
         UI.messagebox "Edge not following the previous one"
       when 5
           UI.beep
      end #end case when
end # def OnLButtonDown


def draw(view)
   #draw is called when we want to display then point
   if(@ip1.valid? and @ip1.display?)
      @ip1.draw view
      @displayed=true
   else
      @displayed=false
   end
end


def panel_rainure_feuillure(view)                                    

  dim_nok = true

   while dim_nok do
   prompts = ["Distance parement ","Largeur ","Profondeur ","Epaulement 1","Epaulement 2 "]
   defaults= [@r_dist,@r_width.to_s,@r_depth.to_s,@shoulder1.to_s,@shoulder2.to_s]
   choices = ["","","","",""]
   results = inputbox prompts, defaults, choices, "Rainure&feuillure"
                      
#puts results.to_s   #return if not results  
   if (results==false)  #g 17 user cancel
      @u_step=2
      @edge1=nil
      if ((@edge2!=nil)&&(@edge2.deleted?!=true)) then @edge2.hidden=false end 
      @edge2=nil
      result = 0
      @oops=5
      return
   end #g 17

   @r_dist=results[0]
   @r_dist=@r_dist.to_l 

   @r_width=results[1]
   @r_width=@r_width.to_l 

   @r_depth=results[2] 
   @r_depth=@r_depth.to_l 

   @shoulder1=results[3]
   @shoulder1=@shoulder1.to_l 

    @shoulder2=results[4]
    @shoulder2=@shoulder2.to_l 

  dim_nok = false
#                      if ($leng <2*@shoulder)||(larg <@c_height) 
#                         dim_nok = true 
#                          UI.messagebox "Mauvaises valeurs de hauteur ou d'epaulement" 
#                       end
   end   #while
end 


def draw(view)
   #draw is called when we want to display then point
   if(@ip1.valid? and @ip1.display?)
      @ip1.draw view
      @displayed=true
   else
      @displayed=false
   end
end



def make_rainure_feuillure(view,mat,back,dx)
   Sketchup.active_model.start_operation "undo"
   p1=Geom::Point3d.new(0,@r_dist,0)
   p2=Geom::Point3d.new(0,@r_dist+@r_width,0)
   p3=Geom::Point3d.new(dx*@r_depth,@r_dist+@r_width,0)
   p4=Geom::Point3d.new(dx*@r_depth,@r_dist,0)
   pt1=p1.transform(back)
   pt2=p2.transform(back)
   pt3=p3.transform(back)
   pt4=p4.transform(back)  
   r_face = $codef.entities.add_face pt1, pt2,pt3, pt4
   r_face.material= mat 
   r_face.back_material =mat

   begin
       status = r_face.followme $select_path
#puts status.to_s
  rescue
       UI.messagebox $!.message
  end
end 

end #end Class Usinage 

def addRainure 
   #function acts as short cut for selecting tool
   @@Usinage="Rainure_Feuillure"
   Sketchup.active_model.select_tool Usinage.new
 end


if(not file_loaded?("Usinage.rb"))
   draw_menu = UI.menu "Draw"
   sub_menu = draw_menu.add_item("Rainure_Feuillure") {addRainure}
end

file_loaded("Usinage.rb")
